diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/taxon/ClassificationDaoHibernateImpl.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/taxon/ClassificationDaoHibernateImpl.java
index e9250404a8..325bf454c1 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/taxon/ClassificationDaoHibernateImpl.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/taxon/ClassificationDaoHibernateImpl.java
@@ -10,6 +10,7 @@
 
 package eu.etaxonomy.cdm.persistence.dao.hibernate.taxon;
 
+import java.util.ArrayList;
 import java.util.Iterator;
 import java.util.List;
 import java.util.Set;
@@ -115,17 +116,16 @@ public class ClassificationDaoHibernateImpl extends IdentifiableDaoBase<Classifi
         return query;
     }
 
-
-
     @Override
     public UUID delete(Classification persistentObject){
         //delete all childnodes, then delete the tree
 
-        Set<TaxonNode> nodes = persistentObject.getChildNodes();
-        Iterator<TaxonNode> nodesIterator = nodes.iterator();
-
-        while(nodesIterator.hasNext()){
-            TaxonNode node = nodesIterator.next();
+        List<TaxonNode> nodes = persistentObject.getChildNodes();
+        List<TaxonNode> nodesTmp = new ArrayList<TaxonNode>(nodes);
+//        Iterator<TaxonNode> nodesIterator = nodes.iterator();
+        
+        
+        for(TaxonNode node : nodesTmp){
             taxonNodeDao.delete(node);
         }
 
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/taxon/TaxonNodeDaoHibernateImpl.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/taxon/TaxonNodeDaoHibernateImpl.java
index 83f5e8cafe..64fdc3ca07 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/taxon/TaxonNodeDaoHibernateImpl.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/taxon/TaxonNodeDaoHibernateImpl.java
@@ -30,7 +30,6 @@ import eu.etaxonomy.cdm.persistence.dao.taxon.ITaxonNodeDao;
 /**
  * @author a.mueller
  * @created 16.06.2009
- * @version 1.0
  */
 @Repository
 @Qualifier("taxonNodeDaoHibernateImpl")
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/occurrence/IOccurrenceDao.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/occurrence/IOccurrenceDao.java
index 573764a00d..435e015418 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/occurrence/IOccurrenceDao.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/occurrence/IOccurrenceDao.java
@@ -16,9 +16,9 @@ import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.cdm.model.media.Media;
 import eu.etaxonomy.cdm.model.name.HomotypicalGroup;
 import eu.etaxonomy.cdm.model.occurrence.DerivationEvent;
-import eu.etaxonomy.cdm.model.occurrence.DerivedUnitBase;
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
 import eu.etaxonomy.cdm.model.occurrence.DeterminationEvent;
-import eu.etaxonomy.cdm.model.occurrence.FieldObservation;
+import eu.etaxonomy.cdm.model.occurrence.FieldUnit;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.model.taxon.TaxonBase;
@@ -119,15 +119,15 @@ public interface IOccurrenceDao extends IIdentifiableDao<SpecimenOrObservationBa
      */
 	public List<DerivationEvent> getDerivationEvents(SpecimenOrObservationBase occurence, Integer pageSize, Integer pageNumber, List<String> propertyPaths);
 	
-	public List<UuidAndTitleCache<FieldObservation>> getFieldObservationUuidAndTitleCache();
+	public List<UuidAndTitleCache<FieldUnit>> getFieldUnitUuidAndTitleCache();
 	
-	public List<UuidAndTitleCache<DerivedUnitBase>> getDerivedUnitBaseUuidAndTitleCache();
+	public List<UuidAndTitleCache<DerivedUnit>> getDerivedUnitUuidAndTitleCache();
 	
 	/**
 	 * Lists all instances of {@link SpecimenOrObservationBase} which are associated with the <code>taxon</code> specified as parameter.
 	 * SpecimenOrObservationBase instances can be associated to taxa in multiple ways, all these possible relations are taken into account:
 	 * <ul>
-	 * <li>The {@link IndividualsAssociation} elements in a {@link TaxonDescription} contain {@link DerivedUnitBase}s</li>
+	 * <li>The {@link IndividualsAssociation} elements in a {@link TaxonDescription} contain {@link DerivedUnit}s</li>
 	 * <li>{@link SpecimenTypeDesignation}s may be associated with any {@link HomotypicalGroup} related to the specific {@link Taxon}.</li>
 	 * <li>A {@link Taxon} may be referenced by the {@link DeterminationEvent} of the {@link SpecimenOrObservationBase}</li> 
 	 * </ul>
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/statistics/IStatisticsDao.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/statistics/IStatisticsDao.java
new file mode 100644
index 0000000000..a5915d085f
--- /dev/null
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/statistics/IStatisticsDao.java
@@ -0,0 +1,102 @@
+package eu.etaxonomy.cdm.persistence.dao.statistics;
+
+import java.util.List;
+import java.util.Set;
+import java.util.UUID;
+
+import javax.swing.text.StyledEditorKit.BoldAction;
+
+import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
+import eu.etaxonomy.cdm.model.taxon.Classification;
+import eu.etaxonomy.cdm.model.taxon.TaxonBase;
+
+public interface IStatisticsDao {
+
+
+	/**
+	 * counts items of the type Taxon, Synonym or TaxonBase (Taxon & Synonym)
+	 * 
+	 * @param clazz - the Type that will be counted
+	 * @param classification - only items in this classification will be counted
+	 * @return the amount of the items in the classification
+	 */
+	public Long countTaxaInClassification(Class<? extends TaxonBase> clazz,
+			Classification classification);
+
+	
+	/**
+	 * counts all TaxonNames that are attached to the given classification
+	 * 
+	 * @param classification
+	 * @return - the amount of the TaxonNames
+	 */
+	public Long countTaxonNames(Classification classification);
+
+	
+	/**
+	 * counts all NomenclaturalReferences in the data base
+	 * 
+	 * @return the amount of the NRs
+	 */
+	public Long countNomenclaturalReferences();	
+
+	/**
+	 * counts all NomenclaturalReference items attached to the given classification
+	 * 
+	 * @param classification
+	 * @return - the amount of the items in the classification
+	 */
+	public Long countNomenclaturalReferences(Classification classification);
+
+	
+	/**
+	 * count all references that are attached to any description in the data base
+	 * 
+	 * @return - count result - number of these references
+	 */
+	public Long countDescriptiveSourceReferences();
+
+	
+	/**
+	 * count all references that are attached to any description in the given classification
+	 * 
+	 * @return - count result - number of these references
+	 */
+	public Long countDescriptive(Boolean sourceRef,Classification classification);
+
+
+	/**
+	 * count all Reference items attached to the given classification
+	 * but not nomeclatural referencesy
+	 * 
+	 * @param sourceRef - Boolean, tells if to count the descriptions 
+	 * 		directly or count the descriptive source references
+	 * @param classification
+	 * @return - the amount of the items in the classification
+	 */
+	public Long countReferencesInClassification(Classification classification);
+
+	
+	
+	public List<UUID> getTaxonTree(IdentifiableEntity<?> filter);
+
+//	public List<UUID> getAllTaxonIds(UUID rootUuid);
+
+
+	public void getAllTaxonIds();
+
+
+	public List<UUID> getAllChildNodeIds(UUID rootUuid);
+
+
+	
+
+
+	
+
+
+	
+
+
+
+}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/hibernate/CacheStrategyGenerator.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/hibernate/CacheStrategyGenerator.java
index 615f519d95..8c727965d0 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/hibernate/CacheStrategyGenerator.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/hibernate/CacheStrategyGenerator.java
@@ -24,12 +24,12 @@ import eu.etaxonomy.cdm.model.common.ICdmBase;
 import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
 import eu.etaxonomy.cdm.model.common.User;
 import eu.etaxonomy.cdm.model.name.NonViralName;
+import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.cdm.persistence.dao.hibernate.HibernateProxyHelperExtended;
 
 /**
  * @author a.mueller
  * @created 04.03.2009
- * @version 1.0
  */
 public class CacheStrategyGenerator implements SaveOrUpdateEventListener {
 	private static final long serialVersionUID = -5511287200489449838L;
@@ -76,7 +76,12 @@ public class CacheStrategyGenerator implements SaveOrUpdateEventListener {
             	if (! teamOrPerson.isProtectedTitleCache()){
                 	teamOrPerson.setTitleCache(titleCache, false);
             	}
- 
+            
+            //reference caches
+            }else if(Reference.class.isAssignableFrom(entityClazz)){
+            	Reference<?> ref = (Reference<?>)entity;
+            	ref.getAbbrevTitleCache();
+            	ref.getTitleCache();
             //title cache
             }else if(IdentifiableEntity.class.isAssignableFrom(entityClazz)) {
         		IdentifiableEntity<?> identifiableEntity = (IdentifiableEntity)entity;
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/hibernate/CdmPostDataChangeObservableListener.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/hibernate/CdmPostDataChangeObservableListener.java
index 6704b98e0f..d0565829ef 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/hibernate/CdmPostDataChangeObservableListener.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/hibernate/CdmPostDataChangeObservableListener.java
@@ -137,36 +137,28 @@ public class CdmPostDataChangeObservableListener implements
 		}
 	}
 	
-	/* (non-Javadoc)
-	 * @see org.hibernate.event.PostInsertEventListener#onPostInsert(org.hibernate.event.PostInsertEvent)
-	 */
+	@Override
 	public void onPostInsert(PostInsertEvent event) {
 		if(propagateInserts && event.getEntity() instanceof CdmBase){
 			getDefault().notifyObservers(CdmDataChangeEvent.NewInstance(event));
 		}
 	}
 	
-	/* (non-Javadoc)
-	 * @see org.hibernate.event.PostLoadEventListener#onPostLoad(org.hibernate.event.PostLoadEvent)
-	 */
+	@Override
 	public void onPostLoad(PostLoadEvent event) {
 		if(propagateLoads && event.getEntity() instanceof CdmBase){
 			getDefault().notifyObservers(CdmDataChangeEvent.NewInstance(event));
 		}
 	}
 
-	/* (non-Javadoc)
-	 * @see org.hibernate.event.PostUpdateEventListener#onPostUpdate(org.hibernate.event.PostUpdateEvent)
-	 */
+	@Override
 	public void onPostUpdate(PostUpdateEvent event) {
 		if(propagateUpdates && event.getEntity() instanceof CdmBase){
 			getDefault().notifyObservers(CdmDataChangeEvent.NewInstance(event));
 		}
 	}
 
-	/* (non-Javadoc)
-	 * @see org.hibernate.event.PostDeleteEventListener#onPostDelete(org.hibernate.event.PostDeleteEvent)
-	 */
+	@Override
 	public void onPostDelete(PostDeleteEvent event) {
 		if(propagateDeletes && event.getEntity() instanceof CdmBase){
 			getDefault().notifyObservers(CdmDataChangeEvent.NewInstance(event));
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/hibernate/SaveOrUpdateEntityListener.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/hibernate/SaveOrUpdateEntityListener.java
index 335d1055c4..607f9f98fe 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/hibernate/SaveOrUpdateEntityListener.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/hibernate/SaveOrUpdateEntityListener.java
@@ -1,5 +1,16 @@
+// $Id$
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
 package eu.etaxonomy.cdm.persistence.hibernate;
 
+import java.util.List;
+
 import org.hibernate.HibernateException;
 import org.hibernate.event.spi.SaveOrUpdateEvent;
 import org.hibernate.event.spi.SaveOrUpdateEventListener;
@@ -8,6 +19,7 @@ import org.springframework.security.core.Authentication;
 import org.springframework.security.core.context.SecurityContextHolder;
 
 import eu.etaxonomy.cdm.model.common.CdmBase;
+import eu.etaxonomy.cdm.model.common.ITreeNode;
 import eu.etaxonomy.cdm.model.common.User;
 import eu.etaxonomy.cdm.model.common.VersionableEntity;
 
@@ -36,10 +48,53 @@ public class SaveOrUpdateEntityListener implements SaveOrUpdateEventListener {
 					if(authentication != null && authentication.getPrincipal() != null && authentication.getPrincipal() instanceof User) {
 						User user = (User)authentication.getPrincipal();
 						versionableEntity.setUpdatedBy(user);
-					} 
-					
+					}
+				}
+			}
+			
+			if (entity instanceof ITreeNode) {
+				ITreeNode<?> node = (ITreeNode<?>)entity;
+				reindex(event, node);
+				
+			}
+		}
+	}
+
+	static String sep = ITreeNode.separator;
+	static String pref = ITreeNode.treePrefix;
+	
+	/**
+	 * @param event
+	 * @param node
+	 */
+	private <T extends ITreeNode> void reindex(SaveOrUpdateEvent event, T node) {
+		String oldChildIndex = node.treeIndex();
+		ITreeNode<?> parent = node.getParent();
+		String parentIndex = (parent == null) ? (sep + pref + node.treeId() + sep)  : parent.treeIndex();  //TODO
+		if (node.getId() > 0){   //TODO
+			String newChildIndex = parentIndex + node.getId() + sep;
+			if (oldChildIndex == null || ! oldChildIndex.equals(newChildIndex)){
+				node.setTreeIndex(newChildIndex);
 				
+				//TODO this is a greedy implementation, better use update by replace string
+				//either using and improving the below code or by using native SQL
+				//The current approach may run out of memory for large descendant sets.
+				List<T> childNodes = (List<T>)node.getChildNodes();
+				for (T child : childNodes){
+					if (! child.equals(node)){  //node should not be it's own child, however just in case
+						reindex(event, child);
+					}
 				}
+				
+	//			String className = event.getEntityName();
+	//					String updateQuery = " UPDATE %s tn " +
+	//							" SET tn.treeIndex = Replace(tn.treeIndex, '%s', '%s') " +
+	//							" WHERE tn.id <> "+ node.getId()+" ";
+	//					updateQuery = String.format(updateQuery, className, oldChildIndex, parentIndex);  //dummy
+	//					System.out.println(updateQuery);
+	//					EventSource session = event.getSession();
+	//					Query query = session.createQuery(updateQuery);
+	//					query.executeUpdate();
 			}
 		}
 	}
diff --git a/cdmlib-persistence/src/main/java/org/hibernate/dialect/MySQL5MyISAMUtf8Dialect.java b/cdmlib-persistence/src/main/java/org/hibernate/dialect/MySQL5MyISAMUtf8Dialect.java
index 2206f803cd..6c81f90658 100644
--- a/cdmlib-persistence/src/main/java/org/hibernate/dialect/MySQL5MyISAMUtf8Dialect.java
+++ b/cdmlib-persistence/src/main/java/org/hibernate/dialect/MySQL5MyISAMUtf8Dialect.java
@@ -26,15 +26,14 @@ public class MySQL5MyISAMUtf8Dialect extends MySQL5Dialect {
 		registerColumnType(Types.BOOLEAN, "bit");
 	}
 	
-    public String getTableTypeString() {
+    @Override
+	public String getTableTypeString() {
         return " ENGINE=MYISAM DEFAULT CHARSET=utf8";
     }
     
     
 	// compare org.hibernate.dialect.MySQLMyISAMDialect
-    /* (non-Javadoc)
-	 * @see org.hibernate.dialect.Dialect#dropConstraints()
-	 */
+    @Override
 	public boolean dropConstraints() {
 		return false;
 	}
diff --git a/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/database/CdmPersistentDataSourceTest.java b/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/database/CdmPersistentDataSourceTest.java
index 46be95e8ff..35b9b5fda7 100644
--- a/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/database/CdmPersistentDataSourceTest.java
+++ b/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/database/CdmPersistentDataSourceTest.java
@@ -192,7 +192,7 @@ public class CdmPersistentDataSourceTest {
 		
 		Properties properties = (Properties)propValue.getValue();
 		assertEquals(hbm2dll.toString(), properties.getProperty("hibernate.hbm2ddl.auto"));
-		assertEquals(dataSource.getDatabaseType().getHibernateDialect(), properties.getProperty("hibernate.dialect"));
+		assertEquals(dataSource.getDatabaseType().getHibernateDialectCanonicalName(), properties.getProperty("hibernate.dialect"));
 		assertEquals(NoCachingRegionFactory.class.getName(), properties.getProperty("hibernate.cache.region.factory_class"));
 		assertEquals(String.valueOf(false), properties.getProperty("hibernate.show_sql"));
 		assertEquals(String.valueOf(false), properties.getProperty("hibernate.format_sql"));
@@ -229,7 +229,7 @@ public class CdmPersistentDataSourceTest {
 		
 		Properties properties = (Properties)propValue.getValue();
 		assertEquals(hbm2dll.toString(), properties.getProperty("hibernate.hbm2ddl.auto"));
-		assertEquals(dataSource.getDatabaseType().getHibernateDialect(), properties.getProperty("hibernate.dialect"));
+		assertEquals(dataSource.getDatabaseType().getHibernateDialectCanonicalName(), properties.getProperty("hibernate.dialect"));
 		assertEquals(cacheProviderClass.getName(), properties.getProperty("hibernate.cache.region.factory_class"));
 		assertEquals(String.valueOf(showSql), properties.getProperty("hibernate.show_sql"));
 		assertEquals(String.valueOf(formatSql), properties.getProperty("hibernate.format_sql"));
diff --git a/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/database/TestingTermInitializer.java b/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/database/TestingTermInitializer.java
index a12fbf4a8a..f293f980be 100644
--- a/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/database/TestingTermInitializer.java
+++ b/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/database/TestingTermInitializer.java
@@ -9,7 +9,6 @@
 
 package eu.etaxonomy.cdm.database;
 
-import java.io.InputStreamReader;
 import java.sql.SQLException;
 import java.util.HashMap;
 import java.util.UUID;
@@ -22,15 +21,12 @@ import org.dbunit.database.DatabaseConfig;
 import org.dbunit.database.DatabaseConnection;
 import org.dbunit.database.IDatabaseConnection;
 import org.dbunit.dataset.IDataSet;
-import org.dbunit.dataset.ITable;
-import org.dbunit.dataset.xml.FlatXmlDataSet;
+import org.dbunit.dataset.xml.FlatXmlDataSetBuilder;
 import org.dbunit.ext.h2.H2DataTypeFactory;
 import org.dbunit.operation.DatabaseOperation;
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.core.io.Resource;
 import org.springframework.transaction.TransactionStatus;
-import org.unitils.dbunit.datasetfactory.impl.MultiSchemaXmlDataSetFactory;
-import org.unitils.dbunit.util.MultiSchemaDataSet;
 
 import eu.etaxonomy.cdm.model.common.DefinedTermBase;
 import eu.etaxonomy.cdm.model.common.VocabularyEnum;
@@ -90,8 +86,16 @@ public class TestingTermInitializer extends PersistentTermInitializer {
 
 //                logger.info("loading data base schema from " + termsDtd.getFile().getAbsolutePath());
 //                logger.info("loading data set from " + termsDataSet.getFile().getAbsolutePath());
-                IDataSet dataSet = new FlatXmlDataSet(new InputStreamReader(termsDataSet.getInputStream()),new InputStreamReader(termsDtd.getInputStream()));
-//				ITable definedTermBase = dataSet.getTable("DEFINEDTERMBASE");
+
+                
+                //old: IDataSet dataSet = new FlatXmlDataSet(new InputStreamReader(termsDataSet.getInputStream()),new InputStreamReader(termsDtd.getInputStream()));
+
+                IDataSet dataSet = new FlatXmlDataSetBuilder()
+                	.setMetaDataSetFromDtd(termsDtd.getInputStream())
+                	.build(termsDataSet.getInputStream());
+                
+                
+                //ITable definedTermBase = dataSet.getTable("DEFINEDTERMBASE");
 //				for(int rowId = 0; rowId < definedTermBase.getRowCount(); rowId++) {
 //					System.err.println(rowId + " : " + definedTermBase.getValue(rowId, "CREATEDBY_ID"));
 //				}
diff --git a/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/database/TestingTermInitializerTest.java b/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/database/TestingTermInitializerTest.java
index 45afdd82ee..63261632a7 100644
--- a/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/database/TestingTermInitializerTest.java
+++ b/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/database/TestingTermInitializerTest.java
@@ -16,7 +16,6 @@ import java.io.FileNotFoundException;
 import java.io.FileOutputStream;
 import java.util.UUID;
 
-import org.aspectj.weaver.IEclipseSourceContext;
 import org.dbunit.dataset.filter.ExcludeTableFilter;
 import org.junit.Before;
 import org.junit.Test;
